Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java	(nonexistent)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java	(revision 9)
@@ -0,0 +1,586 @@
+/**
+  *
+  *                      OOAS Compiler
+  *
+  *       Copyright 2015, AIT Austrian Institute of Technology.
+  * This code is based on the C# Version of the OOAS Compiler, which is
+  * copyright 2015 by the Institute of Software Technology, Graz University
+  * of Technology with portions copyright by the AIT Austrian Institute of
+  * Technology. All rights reserved.
+  *
+  * SEE THE "LICENSE" FILE FOR THE TERMS UNDER WHICH THIS FILE IS PROVIDED.
+  *
+  * If you modify the file please update the list of contributors below to in-
+  * clude your name. Please also stick to the coding convention of using TABs
+  * to do the basic (block-level) indentation and spaces for anything after
+  * that. (Enable the display of special chars and it should be pretty obvious
+  * what this means.) Also, remove all trailing whitespace.
+  *
+  * Contributors:
+  *               Willibald Krenn (AIT)
+  *               Stephan Zimmerer (AIT)
+  *               Markus Demetz (AIT)
+  *               Christoph Czurda (AIT)
+  *
+  */
+
+
+package org.momut.ooas.ast.types;
+
+import java.util.Iterator;
+
+import org.momut.ooas.ast.AstNode;
+import org.momut.ooas.ast.AstNodeTypeEnum;
+import org.momut.ooas.ast.IAst;
+import org.momut.ooas.ast.IAstVisitor;
+import org.momut.ooas.ast.identifiers.TypeIdentifier;
+import org.momut.ooas.utils.exceptions.ArgumentException;
+import org.momut.ooas.utils.exceptions.NotImplementedException;
+import org.momut.ooas.utils.exceptions.OoasCompilerRuntimeException;
+
+public abstract class Type extends AstNode implements IAst
+{
+	private String m_origAnonName;
+	protected TypeKind m_kind;
+	protected TypeIdentifier m_identifier;
+	protected int m_hash;
+	//    protected long TimeStamp = DateTime.Now.Ticks;
+
+
+	public TypeKind kind() { return m_kind; }
+
+	public TypeIdentifier identifier() {
+		synchronized(this) {
+			if (m_identifier == null)
+				SetupAnonymousName();
+		}
+		return m_identifier;
+	}
+
+	public boolean isAnonymousType() {
+		final String anonName = AnonymousName();
+		if (!m_origAnonName.equals(anonName))
+			throw new OoasCompilerRuntimeException("Internal Error: Anonymous Name changed from '%s' to '%s'.", m_origAnonName, anonName);
+		return anonName.equals(m_identifier.tokenText());
+	}
+
+	protected Type(TypeKind aKind, TypeIdentifier anIdentifier)
+	{
+		m_kind = aKind;
+		m_identifier = anIdentifier;
+		m_hash = aKind.toString().hashCode(); //Enum.GetName(typeof(TypeKind), aKind).GetHashCode();
+	}
+
+	@Override
+	public String toString()
+	{
+		return identifier().tokenText();
+	}
+
+	public /*virtual*/ String AnonymousName()
+	{
+		throw new NotImplementedException();
+	}
+
+
+	public void SetTypeIdentifier(TypeIdentifier anId)
+	{
+		m_identifier = anId;
+	}
+
+	public void SetupAnonymousName()
+	{
+		if (m_identifier == null)
+		{
+			final String anonymousName = this.AnonymousName();
+			m_identifier = new TypeIdentifier(anonymousName, this, null);
+			m_origAnonName = anonymousName;
+		}
+	}
+
+
+	@Override
+	public AstNodeTypeEnum nodeType() { return AstNodeTypeEnum.type; }
+
+	@Override
+	public void Accept(IAstVisitor visitor)
+	{
+		throw new NotImplementedException();
+	}
+
+
+
+	public boolean IsNumeric()
+	{
+		final Object o = this;
+		return (m_kind == TypeKind.IntType) ||
+				(m_kind == TypeKind.FloatType) ||
+				(m_kind == TypeKind.EnumeratedType && o instanceof ValuedEnumType);
+	}
+
+	public boolean IsQualitative()
+	{
+		return (m_kind == TypeKind.QrType);
+	}
+
+	/**
+	 * returns the number of unique values of the type (2 for bool, etc..)
+	 */
+	public int valueCount() {
+		throw new NotImplementedException(); // must be overridden by child
+	}
+
+	public static String High(Type atype)
+	{
+		switch (atype.kind())
+		{
+			case BoolType:
+				return "1";
+			case EnumeratedType:
+				return Integer.toString((((EnumType)atype).listOfEnumSymbols().size() - 1));
+			case IntType:
+				return Integer.toString(((IntType)atype).rangeHigh());
+			case FloatType:
+				return Double.toString(((FloatType)atype).high());
+			default:
+				throw new NotImplementedException();
+		}
+	}
+
+	public static String Low(Type atype)
+	{
+		switch (atype.kind())
+		{
+			case BoolType:
+				return "0";
+			case EnumeratedType:
+				return "0";
+			case IntType:
+				return Integer.toString(((IntType)atype).rangeLow());
+			case FloatType:
+				return Double.toString(((FloatType)atype).low());
+//			case TypeKind.QrType:
+//				return "0";
+			default:
+				throw new NotImplementedException();
+		}
+	}
+
+
+	/// <summary>
+	///  Returns a cover for two types (if possible).
+	///  note the cover type for two ints, floats, etc. will have max/min values
+	///  that reflect the maximum of the two operands.
+	/// </summary>
+
+	public static Type CoverType(Type type1, Type type2)
+	{
+		/*first some sanity checks*/
+		if (type1 == null)
+			throw new ArgumentException("type1 null");
+		if (type2 == null)
+			throw new ArgumentException("type2 null");
+
+		if (type1.kind() == TypeKind.OpaqueType)
+			throw new ArgumentException("type1 opaque type");
+		if (type2.kind() == TypeKind.OpaqueType)
+			throw new ArgumentException("type2 opaque type");
+
+		if (type1 == type2)
+			return type1;
+		if (Type.TypeEqual(type1, type2))
+			return type1;
+
+		final TypeKind tk1 = type1.kind();
+		final TypeKind tk2 = type2.kind();
+
+
+
+		if (tk1 != tk2)
+		{
+			// the only notion we support here is int->float and valenum -> int
+			if ((tk1 == TypeKind.IntType || tk2 == TypeKind.IntType)
+					&& (tk1 == TypeKind.FloatType || tk2 == TypeKind.FloatType))
+			{
+				final IntType aInt = tk1 == TypeKind.IntType ? (IntType)type1 : (IntType)type2;
+				final FloatType aFloat = tk1 == TypeKind.IntType ? (FloatType)type2 : (FloatType)type1;
+
+				final double low = aInt.rangeLow() < aFloat.low() ? (double)aInt.rangeLow() : aFloat.low();
+				final double high = aInt.rangeHigh() < aFloat.high() ? aFloat.high() : (double)aInt.rangeHigh();
+				final double precision = aFloat.precision() > 1 ? 1.0 : aFloat.precision();
+
+				return new FloatType(low, high, precision, null);
+
+			}
+			else if ((tk1 == TypeKind.IntType || tk2 == TypeKind.IntType)
+					&& (tk1 == TypeKind.EnumeratedType || tk2 == TypeKind.EnumeratedType))
+			{
+				final IntType intt1 = tk1 == TypeKind.IntType ? (IntType)type1 : (IntType)type2;
+				final EnumType anEnum = tk1 == TypeKind.IntType ? (EnumType)type2 : (EnumType)type1;
+
+				if (anEnum instanceof ValuedEnumType)
+				{
+					final IntType intt2 = ((ValuedEnumType)anEnum).getIntType();
+					final int low = intt1.rangeLow() < intt2.rangeLow() ? intt1.rangeLow() : intt2.rangeLow();
+					final int high = intt1.rangeHigh() > intt2.rangeHigh() ? intt1.rangeHigh() : intt2.rangeHigh();
+					return new IntType(low, high, null);
+				}
+				else
+					return null;
+			}
+			else if (tk1 == TypeKind.Any || tk2 == TypeKind.Any)
+			{
+				final AnyType freeVar = tk1 == TypeKind.Any ? (AnyType)type1 : (AnyType)type2;
+				final Type fixedType = tk1 == TypeKind.Any ? type2 : type1;
+				final Type newcover = freeVar.VariableIdentifier().type().kind() == TypeKind.Any
+						? fixedType : CoverType(fixedType, freeVar.VariableIdentifier().type());
+				freeVar.VariableIdentifier().SetType(newcover);
+				return newcover;
+			}
+			else if (tk1 == TypeKind.OoActionSystemType && tk2 == TypeKind.Null)
+			{
+				return type1;
+			}
+			else if (tk2 == TypeKind.OoActionSystemType && tk1 == TypeKind.Null)
+			{
+				return type2;
+			}
+
+			else
+				return null;
+		}
+		else
+		{
+			switch (tk1)
+			{
+				case Any:
+					return type1;
+
+				case IntType:
+					final IntType intt1 = (IntType)type1;
+					final IntType intt2 = (IntType)type2;
+					final int low = intt1.rangeLow() < intt2.rangeLow() ? intt1.rangeLow() : intt2.rangeLow();
+					final int high = intt1.rangeHigh() > intt2.rangeHigh() ? intt1.rangeHigh() : intt2.rangeHigh();
+					return new IntType(low, high, null);
+				case BoolType:
+					return type1;
+				case FloatType:
+					final FloatType floatt1 = (FloatType)type1;
+					final FloatType floatt2 = (FloatType)type2;
+					final double flow = floatt1.low() < floatt2.low() ? floatt1.low() : floatt2.low();
+					final double fhigh = floatt1.high() > floatt2.high() ? floatt1.high() : floatt2.high();
+					final double fprec = floatt1.precision() < floatt2.precision() ? floatt1.precision() : floatt2.precision();
+					return new FloatType(flow, fhigh, fprec, null);
+				case EnumeratedType:
+					return null;
+				case ListType:
+					final ListType listt1 = (ListType)type1;
+					final ListType listt2 = (ListType)type2;
+					int maxelems = listt1.maxNumberOfElements() > listt2.maxNumberOfElements() ?
+						listt1.maxNumberOfElements() : listt2.maxNumberOfElements();
+					// empty lists lack type, so take the other one
+					if ((listt1.innerType().kind() == TypeKind.Null) && (listt2.innerType().kind() != TypeKind.Null))
+						return listt2;
+					else if ((listt2.innerType().kind() == TypeKind.Null) && (listt1.innerType().kind() != TypeKind.Null))
+						return listt1;
+					else if (listt1.innerType().kind() == TypeKind.Null && listt2.innerType().kind() == TypeKind.Null)
+						return listt1;
+					else
+					{
+						final Type subtype = Type.CoverType(listt1.innerType(), listt2.innerType());
+						if (subtype != null)
+							return new ListType(subtype, maxelems, null);
+						else
+							return null;
+					}
+				case MapType:
+					final MapType mapt1 = (MapType)type1;
+					final MapType mapt2 = (MapType)type2;
+					// empty maps lack type, so take the other one.
+					if ((mapt1.fromType().kind() == TypeKind.Null && mapt1.toType().kind() == TypeKind.Null)
+					   && (mapt2.fromType().kind() != TypeKind.Null && mapt2.toType().kind() != TypeKind.Null))
+						return mapt2;
+					else if ((mapt2.fromType().kind() == TypeKind.Null && mapt2.toType().kind() == TypeKind.Null)
+					   && (mapt1.fromType().kind() != TypeKind.Null && mapt1.toType().kind() != TypeKind.Null))
+						return mapt1;
+					else if ((mapt2.fromType().kind() == TypeKind.Null && mapt2.toType().kind() == TypeKind.Null)
+					   && (mapt1.fromType().kind() == TypeKind.Null && mapt1.toType().kind() == TypeKind.Null))
+						return mapt1;
+					else
+					{
+						final Type sub1 = Type.CoverType(mapt1.fromType(), mapt2.fromType());
+						final Type sub2 = Type.CoverType(mapt2.toType(), mapt2.toType());
+						maxelems = mapt1.maxNumberOfElements() > mapt2.maxNumberOfElements() ?
+							mapt1.maxNumberOfElements() : mapt2.maxNumberOfElements();
+						if (sub1 != null && sub2 != null)
+							return new MapType(sub1, sub2, maxelems, null);
+						else
+							return null;
+					}
+				case QrType:
+					return null; /*if refs are equal, we do not reach this statement! see above..*/
+				case TupleType:
+					final TupleType tuplet1 = (TupleType)type1;
+					final TupleType tuplet2 = (TupleType)type2;
+					final TupleType result = new TupleType(null);
+					final Iterator<Type> innert1 = tuplet1.innerTypes().iterator();
+					final Iterator<Type> innert2 = tuplet2.innerTypes().iterator();
+					while (innert1.hasNext())
+					{
+						final Type newinner = Type.CoverType(innert1.next(), innert2.next());
+						if (newinner == null)
+							return null;
+						result.AddType(newinner);
+					}
+					return result;
+				case OoActionSystemType:
+					if (type1.kind() == TypeKind.Null && type2.kind() != TypeKind.Null)
+						return type2;
+					else if (type2.kind() == TypeKind.Null && type1.kind() != TypeKind.Null)
+						return type1;
+					else if (type1.kind() == TypeKind.Null && type2.kind() == TypeKind.Null)
+						return type2;
+					else if (type1 == type2) // ref equals!
+						return type1;
+					else
+						return ClassBaseType((OoActionSystemType)type1, (OoActionSystemType)type2);
+				case OpaqueType:
+					assert(false);
+					return null;
+				default:
+					throw new NotImplementedException();
+			}
+		}
+	}
+
+	private static Type ClassBaseType(OoActionSystemType type1, OoActionSystemType type2)
+	{
+		// this is rather inefficient.. should be done differently
+		final OoActionSystemType typea = type1;
+		final OoActionSystemType typeb = type2;
+		OoActionSystemType basea = type1;
+		OoActionSystemType baseb = type2;
+		while (basea != null)
+		{
+			if (basea == typeb)  // ref equals
+				return basea;
+			basea = basea.baseType();
+		}
+		while (baseb != null)
+		{
+			if (baseb == typea) // ref equals
+				return baseb;
+			baseb = baseb.baseType();
+		}
+		return null;
+	}
+
+	public static boolean FirstTypeLessRange(Type type1, Type type2)
+	{
+		final TypeKind tk1 = type1.kind();
+		final TypeKind tk2 = type2.kind();
+
+		if (tk1 != tk2)
+			throw new ArgumentException("Types need to be equal");
+
+		switch (tk1)
+		{
+			case Any:
+				return false;
+			case IntType:
+				final IntType Int1 = (IntType)type1;
+				final IntType Int2 = (IntType)type2;
+				return Int1.rangeLow() > Int2.rangeLow() ||
+					Int1.rangeHigh() < Int2.rangeHigh();
+			case BoolType:
+				return false;
+			case FloatType:
+				final FloatType Float1 = (FloatType)type1;
+				final FloatType Float2 = (FloatType)type2;
+				return Float1.low() > Float2.low()
+					|| Float1.high() < Float2.high()
+					|| Float1.precision() > Float2.precision();
+			case EnumeratedType:
+				return false;
+			case ListType:
+				final ListType listt1 = (ListType)type1;
+				final ListType listt2 = (ListType)type2;
+				return (listt1.maxNumberOfElements() < listt2.maxNumberOfElements()) ||
+					Type.FirstTypeLessRange(listt1.innerType(), listt2.innerType());
+			case MapType:
+				final MapType mapt1 = (MapType)type1;
+				final MapType mapt2 = (MapType)type2;
+				return (mapt1.maxNumberOfElements() < mapt2.maxNumberOfElements()) ||
+					Type.FirstTypeLessRange(mapt1.fromType(), mapt2.fromType()) ||
+					Type.FirstTypeLessRange(mapt1.toType(), mapt2.toType());
+			case QrType:
+				return false;
+			case TupleType:
+				final TupleType tuplet1 = (TupleType)type1;
+				final TupleType tuplet2 = (TupleType)type2;
+				if (tuplet1.innerTypes().size() != tuplet2.innerTypes().size())
+					return false;
+				final Iterator<Type> innert1 = tuplet1.innerTypes().iterator();
+				final Iterator<Type> innert2 = tuplet2.innerTypes().iterator();
+				while (innert1.hasNext())
+				{
+					if (Type.FirstTypeLessRange(innert1.next(), innert2.next()))
+						return true;
+				}
+				return false;
+			case OoActionSystemType:
+				return false;
+			case OpaqueType:
+				assert(false);
+				return false;
+			default:
+				throw new NotImplementedException();
+		}
+	}
+
+	public static boolean TypeEqualByKind(Type type1, Type type2)
+	{
+		if ((type1 == null) || (type2 == null))
+			return false;
+
+		final TypeKind tk1 = type1.kind();
+		final TypeKind tk2 = type2.kind();
+
+		// if of different kind, then return false..
+		if (tk1 != tk2)
+			return false;
+
+		// if same kind, make a rigorous check
+		switch (tk1)
+		{
+			case Any:
+				return true;
+
+			case IntType:
+			case BoolType:
+			case FloatType:
+				return true;
+			case EnumeratedType:
+				return type1 == type2; // ref equals
+			case ListType:
+				final ListType listt1 = (ListType)type1;
+				final ListType listt2 = (ListType)type2;
+				return Type.TypeEqualByKind(listt1.innerType(), listt2.innerType());
+			case MapType:
+				final MapType mapt1 = (MapType)type1;
+				final MapType mapt2 = (MapType)type2;
+				return Type.TypeEqualByKind(mapt1.fromType(), mapt2.fromType()) &&
+					Type.TypeEqualByKind(mapt1.toType(), mapt2.toType());
+			case TupleType:
+				final TupleType tuplet1 = (TupleType)type1;
+				final TupleType tuplet2 = (TupleType)type2;
+				if (tuplet1.innerTypes().size() != tuplet2.innerTypes().size())
+					return false;
+				final Iterator<Type> innert1 = tuplet1.innerTypes().iterator();
+				final Iterator<Type> innert2 = tuplet2.innerTypes().iterator();
+				while (innert1.hasNext())
+				{
+					if (!Type.TypeEqualByKind(innert1.next(), innert2.next()))
+						return false;
+				}
+				return true;
+			case OoActionSystemType:
+				return type1 == type2; // ref equ.
+			case OpaqueType:
+				assert(false);
+				return false;
+			default:
+				throw new NotImplementedException();
+		}
+	}
+
+
+	public static boolean TypeEqual(Type type1, Type type2)
+	{
+		// this will also work with opaque types...
+		while (type1 instanceof OpaqueType)
+			type1 = ((OpaqueType)type1).resolvedType();
+		while (type2 instanceof OpaqueType)
+			type2 = ((OpaqueType)type2).resolvedType();
+
+		if ((type1 == null) || (type2 == null))
+			return false;
+
+		final TypeKind tk1 = type1.kind();
+		final TypeKind tk2 = type2.kind();
+
+		// if of different kind, then return false..
+		if (tk1 != tk2)
+			return false;
+
+		// if same kind, make a rigorous check
+		switch (tk1)
+		{
+			case IntType:
+				final IntType intt1 = (IntType)type1;
+				final IntType intt2 = (IntType)type2;
+				return intt1.rangeLow() == intt2.rangeLow() &&
+					intt1.rangeHigh() == intt2.rangeHigh();
+			case BoolType:
+				return true;
+			case FloatType:
+				final FloatType floatt1 = (FloatType)type1;
+				final FloatType floatt2 = (FloatType)type2;
+				return floatt1.low() == floatt2.low() &&
+					floatt1.high() == floatt2.high() &&
+					floatt1.precision() == floatt2.precision();
+			case EnumeratedType:
+				return type1 == type2; // ref equ
+			case ListType:
+				final ListType listt1 = (ListType)type1;
+				final ListType listt2 = (ListType)type2;
+				// an empty list can be of any type..
+				/*if ((listt1.innerType.kind == TypeKind.Null) || (listt2.innerType.kind == TypeKind.Null))
+					return true;
+				else*/
+				return Type.TypeEqual(listt1.innerType(), listt2.innerType()) &&
+						listt1.maxNumberOfElements() == listt2.maxNumberOfElements(); // need this because of covertype
+			case MapType:
+				final MapType mapt1 = (MapType)type1;
+				final MapType mapt2 = (MapType)type2;
+				return Type.TypeEqual(mapt1.fromType(), mapt2.fromType()) &&
+					Type.TypeEqual(mapt1.toType(), mapt2.toType()) &&
+					mapt1.maxNumberOfElements() == mapt2.maxNumberOfElements(); // need this because of covertype
+			case TupleType:
+				final TupleType tuplet1 = (TupleType)type1;
+				final TupleType tuplet2 = (TupleType)type2;
+				if (tuplet1.innerTypes().size() != tuplet2.innerTypes().size())
+					return false;
+				final Iterator<Type> innert1 = tuplet1.innerTypes().iterator();
+				final Iterator<Type> innert2 = tuplet2.innerTypes().iterator();
+				while (innert1.hasNext())
+				{
+					if (!Type.TypeEqual(innert1.next(), innert2.next()))
+						return false;
+				}
+				return true;
+			case OoActionSystemType:
+				return type1 == type2; // ref equ. // || Covariance((OoActionSystemType)type1, (OoActionSystemType)type2);
+			case OpaqueType:
+				assert(false);
+				return false;
+			case Null:
+			case Any:
+				return true;
+			default:
+				throw new NotImplementedException();
+		}
+	}
+
+	/// <summary>
+	/// checks if type 2 is a desc. of type 1
+	/// </summary>
+	public static boolean Covariance(OoActionSystemType ooActionSystemType, OoActionSystemType ooActionSystemType_2)
+	{
+		// check if type 2 is a desc. of type 1
+		while (ooActionSystemType != ooActionSystemType_2 && ooActionSystemType_2.baseType() != null) // ref equ.
+			ooActionSystemType_2 = ooActionSystemType_2.baseType();
+
+		return ooActionSystemType == ooActionSystemType_2; // ref equ.
+	}
+}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpIdentifier.java	(revision 9)
@@ -33,7 +33,6 @@
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -50,7 +49,7 @@
 import org.momut.ooas.ast.types.FunctionType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.visitors.OoaCompleteAstTraversalVisitor;
 
@@ -85,12 +84,8 @@
 			m_emitter.Append(" */ ");
 		}
 	}
+
 	@Override
-	public  void visit(LandmarkIdentifier landmarkIdentifier)
-	{
-		throw new UnsupportedOperationException();
-	}
-	@Override
 	public  void visit(AttributeIdentifier attributeIdentifier)
 	{
 		if (m_stateVariablePrefix != null && !m_stateVariablePrefix.equals(""))
@@ -139,7 +134,7 @@
 		{
 			final FunctionType funType = (FunctionType) typeIdentifier.type();
 			m_emitter.Append(typeIdentifier.tokenText());
-			for (final UlyssesType x : funType.parameter())
+			for (final Type x : funType.parameter())
 			{
 				m_emitter.Append("_");
 				m_emitter.Append(x.toString());
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/OoaCADPVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/OoaCADPVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/OoaCADPVisitor.java	(revision 9)
@@ -44,7 +44,7 @@
 import org.momut.ooas.ast.statements.Block;
 import org.momut.ooas.ast.types.FunctionType;
 import org.momut.ooas.ast.types.OoActionSystemType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.FunctionType.FunctionTypeEnum;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.parser.ParserState;
@@ -484,7 +484,7 @@
 	}
 
 
-	public static String DumpType(UlyssesType atype)
+	public static String DumpType(Type atype)
 	{
 		final CadpType newtype = new CadpType();
 		atype.Accept(newtype);
@@ -768,7 +768,7 @@
 				{
 					param.append("    struct {"); param.append(System.lineSeparator());
 					int parnum = 0;
-					for (final UlyssesType parameter: ((FunctionType)namedAction.type()).parameter())
+					for (final Type parameter: ((FunctionType)namedAction.type()).parameter())
 					{
 						param.append(String.format("        %1$s PARAM_%2$s;", DumpType(parameter), parnum));
 						param.append(System.lineSeparator());
@@ -977,7 +977,7 @@
 				m_output.AppendLine(String.format("    case %1$s:", num));
 				m_output.Append("      return ");
 				int paramnr = 0;
-				for (final UlyssesType param: ((FunctionType)action.type()).parameter())
+				for (final Type param: ((FunctionType)action.type()).parameter())
 				{
 					if (paramnr != 0)
 						m_output.AppendLine(" && ");
@@ -1032,7 +1032,7 @@
 			{
 				m_output.AppendLine(String.format("    case %1$s:", num));
 //				int paramnr = 0;
-				for (@SuppressWarnings("unused") final UlyssesType param: ((FunctionType)action.type()).parameter())
+				for (@SuppressWarnings("unused") final Type param: ((FunctionType)action.type()).parameter())
 				{
 					m_output.AppendLine(
 							String.format("      CAESAR_SIZE = sizeof (CAESAR_L->CAESAR_UNION.CAESAR_PROFILE_%1$s);", num));
@@ -1129,7 +1129,7 @@
 				int paramnum = 0;
 				for (final ParameterIdentifier paramname : action.parameter())
 				{
-					final UlyssesType param = paramname.type();
+					final Type param = paramname.type();
 					CadpType.EmitType(param);
 					m_output.AppendLine(String.format("      fprintf(CAESAR_FILE,\"%1$s: \");", paramname.tokenText()));
 					m_output.AppendLine(String.format("      %1$s%4$s(CAESAR_FILE, CAESAR_L->CAESAR_UNION.CAESAR_PROFILE_%2$s.PARAM_%3$s);",
@@ -1201,7 +1201,7 @@
 	{
 		final StringBuilder paramStr = new StringBuilder("CAESAR_TYPE_STATE CAESAR_S1");
 		int i = 0;
-		for (final UlyssesType param : fun.parameter())
+		for (final Type param : fun.parameter())
 		{
 			//CadpType.EmitType(param);
 			paramStr.append(", ");
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaType.java	(revision 9)
@@ -37,7 +37,6 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
@@ -97,11 +96,6 @@
 //		m_emitter.Append("UlyssesDictionary<Object,Object>");
 	}
 
-	@Override
-	public void visit(QrType qrType)
-	{
-		m_emitter.Append("QualitativeValue");
-	}
 
 	@Override
 	public void visit(TupleType tupleType)
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologType.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologType.java	(revision 9)
@@ -29,7 +29,6 @@
 
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.types.BoolType;
 import org.momut.ooas.ast.types.CharType;
 import org.momut.ooas.ast.types.EnumType;
@@ -41,9 +40,8 @@
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
@@ -58,7 +56,7 @@
 
 	protected final Scratchbook m_scratchbook;
 
-	public static void EmitType(UlyssesType aType, OoaPrologIdentifier.Factory idFactory, Scratchbook scratchbook)
+	public static void EmitType(Type aType, OoaPrologIdentifier.Factory idFactory, Scratchbook scratchbook)
 	{
 		final OoaPrologType ptype = new OoaPrologType(idFactory, scratchbook);
 		final OoasCodeEmitter m_emitter = new OoasCodeEmitter();
@@ -176,7 +174,7 @@
 			m_emitter.Append("[");
 			first = true;
 
-			for (final UlyssesType type: tupleType.innerTypes())
+			for (final Type type: tupleType.innerTypes())
 			{
 				final OoaPrologType iType = new OoaPrologType(idFactory, scratchbook);
 				type.Accept(iType);
@@ -191,25 +189,6 @@
 			m_emitter.AppendLine("]).");
 			break;
 
-		case QrType:
-			aType.Accept(ptype);
-			final QrType qrtype = (QrType)aType;
-
-			final StringBuilder landmarks = new StringBuilder();
-			int cntr = 0;
-			for (final LandmarkIdentifier s: qrtype.landmarks())
-			{
-				if (cntr != 0)
-					landmarks.append(", ");
-				else
-					cntr++;
-
-				final OoaPrologIdentifier identifierVisitor = idFactory.create();
-				s.Accept(identifierVisitor);
-				landmarks.append(identifierVisitor.toString());
-			}
-			m_emitter.AppendLine(String.format("qspace( %s, [%s] ).", ptype.toString(), landmarks.toString()));
-			break;
 		default:
 			throw new NotImplementedException();
 		}
@@ -220,14 +199,14 @@
 	private final OoasCodeEmitter m_emitter = new OoasCodeEmitter();
 	private final OoaPrologIdentifier.Factory m_idFactory;
 
-	public /*override*/ @Override
-	void visit(CharType charType)
+	@Override
+	public void visit(CharType charType)
 	{
 		m_emitter.Append("char");
 	}
 
-	public /*override*/ @Override
-	void visit(IntType intType)
+	@Override
+	public void visit(IntType intType)
 	{
 		final OoaPrologIdentifier id = m_idFactory.create();
 		intType.identifier().Accept(id);
@@ -235,20 +214,20 @@
 		m_emitter.Append(id.toString());
 	}
 
-	public /*override*/ @Override
-	void visit(BoolType boolType)
+	@Override
+	public void visit(BoolType boolType)
 	{
 		m_emitter.Append("bool");
 	}
 
-	public /*override*/ @Override
-	void visit(FloatType floatType)
+	@Override
+	public void visit(FloatType floatType)
 	{
 		throw new NotImplementedException();
 	}
 
-	public /*override*/ @Override
-	void visit(EnumType enumType)
+	@Override
+	public void visit(EnumType enumType)
 	{
 		final OoaPrologIdentifier id = m_idFactory.create();
 		enumType.identifier().Accept(id);
@@ -256,8 +235,8 @@
 		m_emitter.Append(id.toString());
 	}
 
-	public /*override*/ @Override
-	void visit(ListType listType)
+	@Override
+	public void visit(ListType listType)
 	{
 		final OoaPrologIdentifier id = m_idFactory.create();
 		listType.identifier().Accept(id);
@@ -266,23 +245,15 @@
 
 	}
 
-	public /*override*/ @Override
-	void visit(MapType mapType)
+	@Override
+	public void visit(MapType mapType)
 	{
 		throw new NotImplementedException();
 	}
 
-	public /*override*/ @Override
-	void visit(QrType qrType)
-	{
-		final OoaPrologIdentifier id = m_idFactory.create();
-		qrType.identifier().Accept(id);
-		m_emitter.Append(id.toString());
-		// m_emitter.Append(qrType.identifier.tokenText.ToLower());
-	}
 
-	public /*override*/ @Override
-	void visit(TupleType tupleType)
+	@Override
+	public void visit(TupleType tupleType)
 	{
 		final OoaPrologIdentifier id = m_idFactory.create();
 		tupleType.identifier().Accept(id);
@@ -290,14 +261,14 @@
 		m_emitter.Append(id.toString());
 	}
 
-	public /*override*/ @Override
-	void visit(FunctionType functionType)
+	@Override
+	public void visit(FunctionType functionType)
 	{
 		throw new NotImplementedException();
 	}
 
-	public /*override*/ @Override
-	void visit(OoActionSystemType ooActionSystemType)
+	@Override
+	public void visit(OoActionSystemType ooActionSystemType)
 	{
 		final OoaPrologIdentifier id = m_idFactory.create();
 		ooActionSystemType.identifier().Accept(id);
@@ -304,8 +275,8 @@
 		m_emitter.Append(id.toString());
 	}
 
-	public /*override*/ @Override
-	void visit(OpaqueType opaqueType)
+	@Override
+	public void visit(OpaqueType opaqueType)
 	{
 		throw new NotImplementedException();
 	}
@@ -312,7 +283,7 @@
 
 
 	@Override
-	public /*override*/ String toString()
+	public String toString()
 	{
 		return m_emitter.toString();
 	}
